#!/usr/bin/env python

import urllib
import sys
import time
import os.path

data = ('coreutils', 'aspell', 'bash', 'console-tools', 'cpio', 'e2fsprogs',
        'enscript', 'findutils', 'flex', 'gawk', 'grep', 'wget', 'util-linux',
        'texinfo', 'tar', 'sharutils', 'shared-mime-info', 'sed',
        'scrollkeeper', 'rpm', 'psmisc', 'parted', 'nano', 'man-db', 'minicom',
        'lynx', 'hello',
        ('binutils', 'bfd', 'binutils', 'gas', 'gprof', 'ld'),
        ('bison', 'bison', 'bison-runtime'),
        ('gettext', 'gettext-runtime', 'gettext-tools'),
        ('gstreamer0.10', 'gstreamer-0.10'),
        ('make-dfsg', 'make'),
        ('iso-codes', 'iso-3166', 'iso-3166-2', 'iso-4217', 'iso-639', 'iso-639-3')
        )

header = '''# this file is generated by update-rosetta-status.py
# do NOT edit it by hand
# it's updated at UTC %s
#
# This is the translation status of specify domain in rosetta, for feisty and zh_CN
# use following url to visit it, remember subst PACKAGE and DOMAIN with correct data
# https://translations.launchpad.net/ubuntu/feisty/+source/PACKAGE/+pots/DOMAIN/zh_CN/
#
# DOMAIN PACKAGE DONE / TOTAL''' % time.asctime(time.gmtime())

def data2pkgdomain():
    for x in data:
        if type(x) is str:
            yield x,x
        else:
            for y in x[1:]:
                yield y, x[0]

def main():
    ofname = os.path.join(os.path.split(sys.argv[0])[0], "..", "ubuntu-feisty-status.txt")
    sys.stdout = file(ofname, 'w')
    print header
    for domainname, pkgname in sorted(data2pkgdomain()):
        print domainname, pkgname,
        sys.stdout.flush()
        url = 'https://translations.launchpad.net/ubuntu/feisty/+source/%s/+pots/%s/zh_CN/' % (pkgname, domainname)
        lines = urllib.urlopen(url).readlines()
        idxs = [i for i, line in enumerate(lines) if "To do:" in line]
        assert len(idxs) == 1, [lines[idx] for idx in idxs]
        idx = idxs[0]
        assert 0 <= idx - 2 and idx + 1 < len(lines)
        total = int(lines[idx-2])
        todo = int(lines[idx+1])
        print total-todo, "/", total
        sys.stdout.flush()

if __name__ == '__main__':
    main()
